<?php

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-mbapi/include/modules/registrar/registrar.php");
require_once mb_path("/lib-mbapi/include/curl/curl.php");
require_once mb_path("/lib-action/include/input/input.php");



$className = "internetbscorp";
$GLOBALS["moduleInfo"][$className] = array
(
    "type" => "Registrar",
    "status" => "TRANS_STABLE",
    "version" => "1.0.0",
    "displayName" => "internetbscorp",
    "author" => "Internet.bs Corp."
);

class internetbscorp extends Registrar {

	private $dialingCodes=array('US'=>'1','AF'=>'93','AL'=>'355','DZ'=>'213','AS'=>'684','AD'=>'376','AO'=>'244','AI'=>'1','AQ'=>'672','AG'=>'1','AR'=>'54','AM'=>'374','AW'=>'297','AU'=>'61','AT'=>'43','AZ'=>'994','BS'=>'1','BH'=>'973','BD'=>'880','BB'=>'1','BY'=>'375','BE'=>'32','BZ'=>'501','BJ'=>'229','BM'=>'1','BT'=>'975','BO'=>'591','BA'=>'387','BW'=>'267','BR'=>'55','IO'=>'246','BN'=>'673','BG'=>'359','BF'=>'226','BI'=>'257','KH'=>'855','CM'=>'237','CA'=>'1','CV'=>'238','KY'=>'1','CF'=>'236','TD'=>'235','CL'=>'56','CN'=>'86','CX'=>'618','CC'=>'61','CO'=>'57','KM'=>'269','CG'=>'242','CD'=>'243','CK'=>'682','CR'=>'506','CI'=>'225','HR'=>'385','CU'=>'53','CY'=>'357','CZ'=>'420','DK'=>'45','DJ'=>'253','DM'=>'1','DO'=>'1','TP'=>'670','EG'=>'20','SV'=>'503','EC'=>'593','GC'=>'240','ER'=>'291','EE'=>'372','ET'=>'251','FK'=>'500','FO'=>'298','FM'=>'691','FJ'=>'679','FI'=>'358','FR'=>'33','GF'=>'594','PF'=>'689','TF'=>'596','GA'=>'241','GM'=>'220','GE'=>'995','DE'=>'49','GH'=>'233','GI'=>'350','GR'=>'30','GL'=>'299','GD'=>'1','GP'=>'590','GU'=>'1','GT'=>'502','GN'=>'224','GW'=>'245','GY'=>'592','HT'=>'509','HM'=>'61','HN'=>'504','HK'=>'852','HU'=>'36','IS'=>'354','IN'=>'91','ID'=>'62','IR'=>'98','IQ'=>'964','IE'=>'353','IL'=>'972','IT'=>'39','JM'=>'1','JP'=>'81','JO'=>'962','KZ'=>'7','KE'=>'254','KI'=>'686','KP'=>'850','KR'=>'82','KW'=>'965','KG'=>'996','LA'=>'856','LV'=>'371','LB'=>'961','LS'=>'266','LR'=>'231','LY'=>'218','LI'=>'423','LT'=>'370','LU'=>'352','MO'=>'853','MK'=>'389','MG'=>'261','MW'=>'265','MY'=>'60','MV'=>'960','ML'=>'269','MT'=>'356','MH'=>'692','MQ'=>'596','MR'=>'222','MU'=>'230','YT'=>'269','FX'=>'33','MX'=>'52','MD'=>'373','MC'=>'377','MN'=>'976','MS'=>'1','MA'=>'212','MZ'=>'258','MM'=>'95','NA'=>'264','NR'=>'674','NP'=>'977','NL'=>'31','AN'=>'599','NC'=>'687','NZ'=>'64','NI'=>'505','NU'=>'683','NE'=>'227','NG'=>'234','NF'=>'672','MP'=>'1','NO'=>'47','OM'=>'968','PK'=>'92','PW'=>'680','PS'=>'970','PA'=>'507','PG'=>'675','PY'=>'595','PE'=>'51','PH'=>'63','PN'=>'872','PL'=>'48','PT'=>'351','PR'=>'1','QA'=>'974','RE'=>'262','RO'=>'40','RU'=>'7','RW'=>'250','GS'=>'995','WS'=>'684','SM'=>'378','ST'=>'239','SA'=>'966','SN'=>'221','SC'=>'248','SL'=>'232','SG'=>'65','SK'=>'421','SI'=>'386','SB'=>'677','SO'=>'252','ZA'=>'27','ES'=>'34','LK'=>'94','SH'=>'290','KN'=>'1','LC'=>'1','PM'=>'508','VC'=>'1','SD'=>'249','SR'=>'597','SJ'=>'47','SZ'=>'268','SE'=>'46','CH'=>'41','SY'=>'963','TW'=>'886','TJ'=>'992','TZ'=>'255','TH'=>'66','TG'=>'228','TK'=>'690','TO'=>'676','TT'=>'1','TN'=>'216','TR'=>'90','TM'=>'993','TC'=>'1','TV'=>'688','UG'=>'256','UA'=>'380','AE'=>'971','GB'=>'44','UM'=>'1','UY'=>'598','UZ'=>'998','VU'=>'678','VA'=>'39','VE'=>'58','VN'=>'84','VG'=>'1','VI'=>'340','WF'=>'681','EH'=>'212','YE'=>'967','YU'=>'381','ZR'=>'243','ZM'=>'260','ZW'=>'263');
	/**
	 * Returns the module display for the InternetBsCorp module. This includes version number and display name.
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 *
	 * @return	An array of arrays containing all the display info for the module.
	 */
	function getModuleInfo() {
		return $GLOBALS["moduleInfo"]["internetbscorp"];
	}

	/**
	 * Construct a new InternetBsCorp object. This function merely sets up capabilities after calling the
	 * constructor for Registrar.
	 */
	function InternetBsCorp($input) {


		$this->capabilities[REGISTRAR_REGISTERDOMAIN] = 1;
		$this->capabilities[REGISTRAR_TRANSFERDOMAIN] = 1;
		$this->capabilities[REGISTRAR_RENEWDOMAIN] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINEXTENDEDINFO] = 1;
		$this->capabilities[REGISTRAR_CHECKDOMAINAVAILABILITY] = 1;
		$this->capabilities[REGISTRAR_CHECKDOMAINTRANSFERAVAILABILITY] = 1;

		//Domain Management options
		$this->capabilities[REGISTRAR_GETDOMAINCONTACTDATA] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINCONTACTDATA] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINRENEWTYPEOPTIONS] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINRENEWTYPEOPTIONS] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINREGISTRARLOCKOPTIONS] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINREGISTRARLOCKOPTIONS] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINACCESSPASSWORD] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINACCESSPASSWORD] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINDNS] = 1;
		$this->capabilities[REGISTRAR_SETDOMAINDNS] = 1;
		$this->capabilities[REGISTRAR_GETDOMAINRENEWDATE] = 1;
		$this->capabilities[REGISTRAR_LIVERENEW] = 1;

		$this->capabilities[REGISTRAR_CHECKACCOUNTBALANCE] = 1;
		$this->capabilities[REGISTRAR_GETTLDPRICING] = 1;
		$this->capabilities[REGISTRAR_GETTRANSFERSTATUS] = 1;
		$this->capabilities[REGISTRAR_GETTLDLIST] = 1;
		$this->capabilities[REGISTRAR_TLDS] = array("com", "net", "org", "biz",'info','fr','eu','co.uk','mobi','org.uk','me.uk','asia','co.in','net.in','org.in','firm.in','gen.in','ind.in');

		//Setup the array of all items to send for new registration
		$this->registrationArray = array(
						"action" => "REGISTER",
						"affiliate_id" => "",
						"auto_renew" => $this->input["tldSettings"]["tldRenewType"],
						"domain" => $this->input["domainSLD"].".".$this->input["domainTLD"],
						"object" => "DOMAIN",
						"contact_set" => array(
										"admin" => array(
													"first_name" => "",
													"last_name" => "",
													"org_name" => "",
													"address1" => "",
													"address2" => "",
													"address3" => "",
													"city" => "",
													"state" => "",
													"country" => "",
													"postal_code" => "",
													"email" => "",
													"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
													"fax" => "",
													"url" => "",
													"lang_pref" => "",
		),
										"billing" => array(
													"first_name" => "",
													"last_name" => "",
													"org_name" => "",
													"address1" => "",
													"address2" => "",
													"address3" => "",
													"city" => "",
													"state" => "",
													"country" => "",
													"postal_code" => "",
													"email" => "",
													"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
													"fax" => "",
													"url" => "",
													"lang_pref" => "",
		),
										"owner" => array(
													"first_name" => "",
													"last_name" => "",
													"org_name" => "",
													"address1" => "",
													"address2" => "",
													"address3" => "",
													"city" => "",
													"state" => "",
													"country" => "",
													"postal_code" => "",
													"email" => "",
													"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
													"fax" => "",
													"url" => "",
													"lang_pref" => "",
		),
										"tech" => array(
													"first_name" => "",
													"last_name" => "",
													"org_name" => "",
													"address1" => "",
													"address2" => "",
													"address3" => "",
													"city" => "",
													"state" => "",
													"country" => "",
													"postal_code" => "",
													"email" => "",
													"phone" => "",	// +CCC.ZZZZZZZZZZZZxYYYY max 20 including the +
													"fax" => "",
													"url" => "",
													"lang_pref" => "",
		),
		),	//Add, remove, or change any of the following as needed for the API called
						"custom_nameserver" => "",	//Only used on transfers.  reg_type = transfer.  If 1, send at least 2 new nameservers for the transfer
						"custom_transfer_nameservers" => "",
						"custom_tech_contact" => "",	//If 0 use the reseller contact
						"domain_description" => "",	//Only used for dot.us domains
						"encoding_type" => "",	//If punycode, send a three letter language tag
						"handle" => "process",
						"isa_tradmark" => "",	//Only used for dot.us domains
						"lang_pref" => "",		//Required for dot.us (probably really for .ca, documentation error)
						"legal_type" => "",		//required for .ca same list as eNom
						"link_domains" => "",
						"period" => 1,
						"reg_password" => "",
						"reg_type" => "",	//new, transfer, whois_privacy
						"reg_username" => "",
						"nameserver_list" => "",
						"tld_data" => array(
										"nexus" => array(
														"app_purpose" => "",
														"category" => "",
														"validator" => "", // required if category is C31 or C32, domain owner's 2 letter country code
		),
										"forwarding_email" => "",
		),
						"registrant_ip" => "",
			
		);

		parent::Registrar($input);
	}

	function _formatPhoneNumber($phoneNumber, $countryCode){
		$phoneNumber = preg_replace("'\D*'si","",$phoneNumber );
		if(preg_match('/^\+[0-9]{1,3}\.[0-9]{3,14}$/i', $phoneNumber)){
			return $phoneNumber;
		} else {
			return "+".$this->dialingCodes[strtoupper($countryCode)].".$phoneNumber";
		}
	}

	function _getCountryByDialingCode($code){
		$code=ltrim($code,"0+");
		foreach ($this->dialingCodes as $cc => $cdiale) {
			if($code==$cdiale) return $cc;
		}
		return "US";
	}

	function runInternetbsCommand($commandPath,$postData){
		$url = $this->getURL();
		$c = new Curl( );
		$c->setURL( $url.$commandPath );
		$c->addField('ApiKey',$this->UID);
		$c->addField('Password',$this->PW);
		$c->addField('ResponseFormat','TEXT');
		foreach ($postData as $key => $value) {
			$c->addField($key,$value);
		}
		$res = $c->toString();
		$CURLerrors = $this->getcurlerrors( $c );
		$result = array();
		$arr = explode("\n",$res);
		foreach($arr as $str) {
			list($varName, $value) = explode("=",$str,2);
			$varName = trim($varName);
			$value = trim($value);
			$result[$varName] = $value;
		}
		$res=var_export($result,true);
		//$exp=var_export($this->input,true);
		$post=var_export($postData,true);
		return $result;

	}

/**
	 * This function sets the connection URL based on TEST mode status.
	 */
	function getURL() {
		global $CONF;

		$internetbsTestMode = $CONF["domain"]["registrar"][strtolower($this->stringRep)][$this->getConfigID()]["moduleTestMode"];
		$url = "https://api.internet.bs/";
		if ($internetbsTestMode) {
			$url = "https://testapi.internet.bs/";
		}
		return $url;
	}

	function setError($trId,$errorCode, $errorMessage){
		$this->adderror( TRANS_MBAPIERROR,"Internet.bs Error: [$errorCode] $errorMessage ($trId)");
		$this->errors[] = array("Module Error: ", "Internet.bs Error: [$errorCode] $errorMessage ($trId)");
	}
	/**
	 * Call the registrar to check a domain's availability for transfer.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function checkDomainTransferAvailability() {
		global $CONF;
		$domainName = $this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/check",array("Domain"=>$domainName));
		if(strtolower($result["status"])=='failure'){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
		} else {
			$this->arrayData['DomainName'] = $domainName;
			$this->arrayData['DomainAvailable'] = strtolower($result['status']) === 'available' ? "false" : "true";

		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * Call the registrar to register a new domain
	 *
	 * @return  string  XML containing registration results for this domain registration
	 */
	function registerDomain() {
		global $CONF;
		//Username is in $this->UID
		//Password is in $this->PW

		$dnsServers=array();
		//What nameservers do we need to pass
		if($this->input["domainNameserver1"]) {
			//This is the panel info pushed from ProcessRegistrar
			$dnsServers[] = $this->input["domainNameserver1"];
			$dnsServers[] = $this->input["domainNameserver2"];
			$dnsServers[] = $this->input["domainNameserver3"];
			$dnsServers[] = $this->input["domainNameserver4"];
		} else {
			//Not tied to a panel, so pull it from the registrar module
			$dnsServers[] = $this->config["domainNameserver1"];
			$dnsServers[] = $this->config["domainNameserver2"];
			$dnsServers[] = $this->config["domainNameserver3"];
			$dnsServers[] = $this->config["domainNameserver4"];
		}


		$tlds = $this->capabilities[REGISTRAR_TLDS];

		if(!in_array($this->input['domainTLD'], $tlds)) {
			$this->setError(0,0,"TLD not supported");
			$this->numErrors ++;
			$this->hasExecutedSuccessfully = 0;
		} else {

			//Popluate contact fields
			$data = $this->getRegistrationContactsData();

			/***********************
			 at this point everything you need can be found in $this->registrationArray or $this->input
			 ***********************/
			$data["Domain"]=$this->input['domainSLD'].".".$this->input['domainTLD'];
			$data["Period"]=$this->input['domainYears'].'Y';
			$nsList=trim(trim(implode(",",$dnsServers),","));
			if($nsList!=''){
				$data["ns_list"]=$nsList;
			}
			if(isset($this->input['idProtect']) && is_array($this->input['idProtect']) && count($this->input['idProtect'])>0){
				if(in_array($this->input['domainTLD'],array('net', 'com', 'org', 'info','mobi', 'biz','asia','in', 'co.in','net.in', 'org.in', 'firm.in', 'gen.in', 'ind.in', 'cc', 'tv'))){
					$data['privateWhois']='FULL';
				}
			}

			/***********************
			 Add your connection code here
			 ***********************/
			$response=$this->runInternetbsCommand("/domain/create",$data);
			if(strtolower($result["status"])!='failure'){
				$this->hasExecutedSuccessfully = 1;
				$this->arrayData = array("OrderID" => $response["transactid"], "domainRemotePurchaseID" => $response["transactid"]);
			} else {
				$this->setError($result["transactid"],$result["code"],$result["message"]);
				$this->numErrors ++;
				$this->hasExecutedSuccessfully = 0;
			}
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * Call the registrar to transfer an existing domain
	 *
	 * @return  string  XML containing registration results for this domain registration
	 */
	function transferDomain() {
		global $CONF;

		//Username is in $this->UID
		//Password is in $this->PW

		$dnsServers=array();
		//What nameservers do we need to pass
		if($this->input["domainNameserver1"]) {
			//This is the panel info pushed from ProcessRegistrar
			$dnsServers[] = $this->input["domainNameserver1"];
			$dnsServers[] = $this->input["domainNameserver2"];
			$dnsServers[] = $this->input["domainNameserver3"];
			$dnsServers[] = $this->input["domainNameserver4"];
		} else {
			//Not tied to a panel, so pull it from the registrar module
			$dnsServers[] = $this->config["domainNameserver1"];
			$dnsServers[] = $this->config["domainNameserver2"];
			$dnsServers[] = $this->config["domainNameserver3"];
			$dnsServers[] = $this->config["domainNameserver4"];
		}


		$tlds = $this->capabilities[REGISTRAR_TLDS];

		if(!in_array($this->input['domainTLD'], $tlds)) {
			$this->errors[] = array("InternetBsCorp Error:", "TLD not supported");
			$this->numErrors ++;
			$this->hasExecutedSuccessfully = 0;
		} else {

			//Popluate contact fields
			$data=$this->getRegistrationContactsData();

			/***********************
			 at this point everything you need can be found in $this->registrationArray or $this->input
			 ***********************/

			//Add connection code

			$tlds = $this->capabilities[REGISTRAR_TLDS];
			$data["Domain"]=$this->input['domainSLD'].".".$this->input['domainTLD'];
			$data["Period"]=$this->input['domainYears'].'Y';
			$nsList=trim(trim(implode(",",$dnsServers),","));
			if($nsList!=''){
				$data["ns_list"]=$nsList;
			}
			$data["registrarLock"]="ENABLED";
			$data["transferAuthInfo"]=$this->input['domainTransferKey'];
			$response=$this->runInternetbsCommand("/domain/transfer/Initiate",$data);
			if(strtolower($result["status"])!='failure'){
				$this->hasExecutedSuccessfully = 1;
				$this->arrayData = array("OrderID" => $response["transactid"], "domainRemotePurchaseID" => $response["transactid"]);
			} else {
				$this->setError($result["transactid"],$result["code"],$result["message"]);
				$this->numErrors ++;
				$this->hasExecutedSuccessfully = 0;
			}
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for renewing a domain.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function renewDomain() {
		global $CONF;
		//Username is in $this->UID
		//Password is in $this->PW
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$period=$this->input['domainYears']."Y";
		$data=array();
		$data["Domain"]=$domainName;
		$data["Period"]=$period;

		$result = $this->runInternetbsCommand("/domain/renew",$data);


		if(!strtolower($result["status"])=='failure') {
			$this->hasExecutedSuccessfully = 1;
			$this->arrayData['DomainRenewSuccess'] = 1;

		} else {
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->arrayData['DomainRenewSuccess'] = 0;
			$this->numErrors ++;
			$this->hasExecutedSuccessfully = 0;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	function getContactDataFromResult($result, $contactType,$prefix){
		$data=array();
		$data["RegistrantPartyID"]="$domainName-$contactType";
		if(array_key_exists("contacts_".$contactType."_firstname",$result)){
			$data[$prefix."FirstName"]=$result["contacts_".$contactType."_firstname"];
		}
		if(array_key_exists("contacts_".$contactType."_lastname",$result)){
			$data[$prefix."LastName"]=$result["contacts_".$contactType."_lastname"];
		}
		if(array_key_exists("contacts_".$contactType."_street",$result)){
			$data[$prefix."Address1"]=$result["contacts_".$contactType."_street"];
		}
		if(array_key_exists("contacts_".$contactType."_street2",$result)){
			$data[$prefix."Address2"]=trim($result["contacts_".$contactType."_street2"]." ".$result["contacts_".$contactType."_street3"]);
		}
		if(array_key_exists("contacts_".$contactType."_city",$result)){
			$data[$prefix."City"]=$result["contacts_".$contactType."_city"];
		}
		if(array_key_exists("contacts_".$contactType."_countrycode",$result)){
			$data[$prefix."Country"]=$result["contacts_".$contactType."_countrycode"];
		}
		if(array_key_exists("contacts_".$contactType."_email",$result)){
			$data[$prefix."EmailAddress"]=$result["contacts_".$contactType."_email"];
		}
		if(array_key_exists("contacts_".$contactType."_phonenumber",$result)){
			$phone=$result["contacts_".$contactType."_phonenumber"];
			$dcode=substr($phone,0,strpos($phone,"."));
			$phone=substr($phone,strpos($phone,".")+1);
			$data[$prefix."Phone"]=$phone;
			$data[$prefix."PhoneDial"]=$this->_getCountryByDialingCode($dcode);

		}
		if(array_key_exists("contacts_".$contactType."_organization",$result)){
			$data[$prefix."OrganizationName"]=$result["contacts_".$contactType."_organization"];
		}
		if(array_key_exists("contacts_".$contactType."_postalcode",$result)){
			$data[$prefix."PostalCode"]=$result["contacts_".$contactType."_postalcode"];
		}

		//.UK
		if(array_key_exists("contacts_".$contactType."_dotukorgtype",$result)){
			$data[$prefix."dot_uk_org_type"]=$result["contacts_".$contactType."_dotukorgtype"];
		}
		if(array_key_exists("contacts_".$contactType."_dotukoptout",$result)){
			$data[$prefix."dot_uk_opt_out"]=$result["contacts_".$contactType."_dotukoptout"];
		}
		if(array_key_exists("contacts_".$contactType."_dotukmobile",$result)){
			$data[$prefix."dot_uk_mobile"]=$result["contacts_".$contactType."_dotukoptout"];
		}
		if(array_key_exists("contacts_".$contactType."_dotuklocality",$result)){
			$data[$prefix."dot_uk_locality"]=$result["contacts_".$contactType."_dotuklocality"];
		}
		if(array_key_exists("contacts_".$contactType."_dotukcounty",$result)){
			$data[$prefix."dot_uk_county"]=$result["contacts_".$contactType."_dotukcounty"];
		}
		if(array_key_exists("contacts_".$contactType."_dotukcounty",$result)){
			$data[$prefix."dot_uk_county"]=$result["contacts_".$contactType."_dotukcounty"];
		}
		if(array_key_exists("contacts_".$contactType."_dotukregistrationnumber",$result)){
			$data[$prefix."dot_uk_registration_number"]=$result["contacts_".$contactType."_dotukregistrationnumber"];
		}

		//.EU
		if(array_key_exists("contacts_".$contactType."_language",$result)){
			$data[$prefix."language"]=$result["contacts_".$contactType."_language"];
		}


		//.FR
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitytype",$result)){
			$data[$prefix."dot_fr_contactentity_type"]=$result["contacts_".$contactType."_dotfrcontactentitytype"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitybirthdate",$result)){
			$data[$prefix."dot_fr_contact_entity_birth_date"]=$result["contacts_".$contactType."_dotfrcontactentitybirthdate"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitybirthcity",$result)){
			$data[$prefix."dot_fr_contact_entity_birth_city"]=$result["contacts_".$contactType."_dotfrcontactentitybirthcity"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitybirthplacepostalcode",$result)){
			$data[$prefix."dot_fr_contact_entity_birth_place_postal_code"]=$result["contacts_".$contactType."_dotfrcontactentitybirthplacepostalcode"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitybirthplacecountrycode",$result)){
			$data[$prefix."dot_fr_contact_entity_birth_place_country_code"]=$result["contacts_".$contactType."_dotfrcontactentitybirthplacecountrycode"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentityrestrictedpublication",$result)){
			$data[$prefix."dot_fr_contact_entity_restricted_publication"]=$result["contacts_".$contactType."_dotfrcontactentityrestrictedpublication"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitysiren",$result)){
			$data[$prefix."dot_fr_contact_entity_siren"]=$result["contacts_".$contactType."_dotfrcontactentitysiren"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitytrademark",$result)){
			$data[$prefix."dot_fr_contact_entity_trademark"]=$result["contacts_".$contactType."_dotfrcontactentitytrademark"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentityvat",$result)){
			$data[$prefix."dot_fr_contact_entity_vat"]=$result["contacts_".$contactType."_dotfrcontactentityvat"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitywaldec",$result)){
			$data[$prefix."dot_fr_contact_entity_waldec"]=$result["contacts_".$contactType."_dotfrcontactentitywaldec"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitydateofassociation",$result)){
			$data[$prefix."dot_fr_contact_entity_date_of_association"]=$result["contacts_".$contactType."_dotfrcontactentitydateofassociation"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitydateofpublication",$result)){
			$data[$prefix."dot_fr_contact_entity_date_of_publication"]=$result["contacts_".$contactType."_dotfrcontactentitydateofpublication"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentityannounceno",$result)){
			$data[$prefix."dot_fr_contact_entity_announce_no"]=$result["contacts_".$contactType."_dotfrcontactentityannounceno"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentitypageno",$result)){
			$data[$prefix."dot_fr_contact_entity_page_no"]=$result["contacts_".$contactType."_dotfrcontactentitypageno"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrothercontactentity",$result)){
			$data[$prefix."dot_fr_other_contact_entity"]=$result["contacts_".$contactType."_dotfrothercontactentity"];
		}
		if(array_key_exists("contacts_".$contactType."_dotfrcontactentityname",$result)){
			$data[$prefix."dot_fr_contact_entity_name"]=$result["contacts_".$contactType."_dotfrcontactentitynamee"];
		}

		//.ASIA
		if(array_key_exists("contacts_".$contactType."_dotasiacedlocality",$result)){
			$data[$prefix."dot_asia_ced_locality"]=$result["contacts_".$contactType."_dotasiacedlocality"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedcity",$result)){
			$data[$prefix."dot_asia_ced_city"]=$result["contacts_".$contactType."_dotasiacedcity"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedentity",$result)){
			$data[$prefix."dot_asia_ced_entity"]=$result["contacts_".$contactType."_dotasiacedentity"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedentityother",$result)){
			$data[$prefix."dot_asia_ced_entity_other"]=$result["contacts_".$contactType."_dotasiacedentityother"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedidform",$result)){
			$data[$prefix."dot_asia_ced_id_form"]=$result["contacts_".$contactType."_dotasiacedidform"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedidformother",$result)){
			$data[$prefix."dot_asia_ced_id_form_other"]=$result["contacts_".$contactType."_dotasiacedidformother"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedidnumber",$result)){
			$data[$prefix."dot_asia_ced_id_number"]=$result["contacts_".$contactType."_dotasiacedidnumber"];
		}
		if(array_key_exists("contacts_".$contactType."_dotasiacedstateprovince",$result)){
			$data[$prefix."dot_asia_ced_state_province"]=$result["contacts_".$contactType."_dotasiacedstateprovince"];
		}

		//.TEL
		if(array_key_exists("contacts_".$contactType."_telhostingaccount",$result)){
			$data[$prefix."tel_hosting_account"]=$result["contacts_".$contactType."_telhostingaccount"];
		}
		if(array_key_exists("contacts_".$contactType."_telhostingpassword",$result)){
			$data[$prefix."tel_hosting_password"]=$result["contacts_".$contactType."_telhostingpassword"];
		}
		if(array_key_exists("contacts_".$contactType."_telhidewhoisdata",$result)){
			$data[$prefix."tel_hide_whois_data"]=$result["contacts_".$contactType."_telhidewhoisdata"];
		}
		return $data;

	}

	/**
	 * Call the registrar to fetch a domain's contact data
	 *
	 * @return  string  XML containing contact data for this domain
	 */
	function getDomainContactData() {
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/info",array("Domain"=>$domainName));
		if(strtolower($result["status"])=="failure"){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData["RegistrantContactData"] = $this->getContactDataFromResult($result,"registrant","Registrant");
			$this->arrayData["BillingContactData"] = $this->getContactDataFromResult($result,"billing","Billing");
			$this->arrayData["TechContactData"] = $this->getContactDataFromResult($result,"technical","Tech");
			$this->arrayData["AdminContactData"] = $this->getContactDataFromResult($result,"admin","Admin");
			$this->hasExecutedSuccessfully = 1;
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	} // END getDomainContactData()

	function getContactDataForUpdate($apiPrefix,$pleskPrefix,$tld){

		if(isset($this->input["domainContactData"][$pleskPrefix])){
			$tld=strtolower($tld);
			$country=isset($this->input["domainContactData"][$pleskPrefix][$pleskPrefix."PhoneDial"])?$this->input["domainContactData"][$pleskPrefix][$pleskPrefix."PhoneDial"]:$this->input["domainContactData"][$pleskPrefix][$pleskPrefix."Country"];
			$data= array(
			$apiPrefix.'_firstname' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."FirstName"],
			$apiPrefix.'_lastname' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."LastName"],
			$apiPrefix.'_organization'=> $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."OrganizationName"],
			$apiPrefix.'_street' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."Address1"],
			$apiPrefix.'_street2' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."Address2"],
			$apiPrefix.'_city' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."City"],
			$apiPrefix.'_countrycode' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."Country"],
			$apiPrefix.'_postalcode' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."PostalCode"],
			$apiPrefix.'_email' => $this->input["domainContactData"][$pleskPrefix][$pleskPrefix."EmailAddress"],
			$apiPrefix.'_phonenumber' =>$this->_formatPhoneNumber($this->input["domainContactData"][$pleskPrefix][$pleskPrefix."Phone"],$country),
			);
			if(in_array($tld,array('uk','eu','fr'))) {
				// for uk, eu, fr contact name cannot be chagned
				unset($data['registrant_firstname']);
				unset($data['registrant_lastname']);
			}
			if($tld=='eu'){
				nset($data['registrant_organization']);
			}
			return $data;
		} else {
			return array();
		}
	}

	/**
	 * Send the updated domain contact data to the registrar
	 *
	 * @return  string  XML result
	 */
	function setDomainContactData() {
		Global $CONF;

		$data = $this->getContactDataForUpdate("registrant","registrant",$this->input['domainTLD']);
		$data=array_merge($data,$this->getContactDataForUpdate("technical","tech",$this->input['domainTLD']));
		$data=array_merge($data,$this->getContactDataForUpdate("admin","admin",$this->input['domainTLD']));
		$data=array_merge($data,$this->getContactDataForUpdate("billing","billing",$this->input['domainTLD']));

		$data["domain"]=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/update",$data);
		if(strtolower($result["status"])=="failure"){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData['OtherData'] = $result;
			$this->hasExecutedSuccessfully = 1;
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * This method contains the registrar specific code for setting a domain's auto-renewal options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setdomainRenewTypeOptions() {
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/update",array("Domain"=>$domainName,"AutoRenew"=>($this->input['domainRenewType']=='1'?"YES":"NO")));
		if(strtolower($result["status"])=="failure"){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData['domainRenewType'] = strtoupper($result["autorenew"])=='YES'?1:0;
			$this->arrayData['EmailForwardAutoRenew'] = 1;
			$this->arrayData['IDProtectAutoRenew'] = 1;
			$this->arrayData['URLForwardAutoRenew'] = 1;

			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * This method contains the registrar specific code for fetching the domain registrar-lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainRegistrarLockOptions() {
		global $CONF;

		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/Domain/RegistrarLock/Status",array("Domain"=>$domainName));
		if(strtolower($result["status"])=='failure'){
			$this->arrayData['DomainIsLockable'] = 0;
			$this->hasExecutedSuccessfully = 1;
		} else {
			$this->hasExecutedSuccessfully = 1;
			$this->arrayData['DomainRegistrarLock'] = $result["registrar_lock_status"]=='LOCKED'? 1 : 0;
			$this->arrayData['DomainIsLockable'] = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	function getdomainRenewTypeOptions(){
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/info",array("Domain"=>$domainName));
		if(strtolower($result["status"])=="failure"){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData['domainRenewType'] = strtoupper($result["autorenew"])=='YES'?1:0;
			$this->arrayData['EmailForwardAutoRenew'] = 1;
			$this->arrayData['IDProtectAutoRenew'] = 1;
			$this->arrayData['URLForwardAutoRenew'] = 1;

			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}
	/**
	 * This method contains the registrar specific code for setting the domain registrar-lock options.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainRegistrarLockOptions() {
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$lock=$this->input['domainRegistrarLock'];
		$command=$lock?"/Domain/RegistrarLock/Enable":"/Domain/RegistrarLock/Disable";
		$result=$this->runInternetbsCommand($command,array("Domain"=>$domainName));
		if(strtolower($result["status"])=='failure'){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData['DomainRegistrarLock'] = $lock? 1 : 0;
			$this->arrayData['DomainIsLockable'] = 1;
			$this->hasExecutedSuccessfully = 1;
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	function getDomainExtendedInfo(){
		global $CONF;

		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/info",array("Domain"=>$domainName));
		if(strtolower($result["status"])=='failure'){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			list($year,$month,$day)=explode("/",$result["expirationdate"]);
			$time=mktime(0,0,0,$month,$day,$year);
			$this->arrayData["DomainExpDate"] = $result["expirationdate"];//"7/8/2007 6:37:25 PM";
			$this->arrayData["DomainExpTimestamp"] = $time; //Unix Timestamp
			$this->arrayData['DomainRenewMaxYears']=10;
			$this->arrayData['DomainRenewDefaultYears'] = 1;
			$this->arrayData['DomainRenewPrice'] = 0;
			$result=$this->runInternetbsCommand("/Account/PriceList/Get",array("Currency"=>'USD'));
			if(strtolower($result["status"])!='failure'){
				$find=".".strtolower($this->input['domainTLD'])." renewal";
				foreach ($result as $key => $value) {
					if($value==$find){
						$v=str_replace("_name","",str_replace("product_","",$key));
						$this->arrayData['DomainRenewPrice']=$result["product_".$v."_price"];
						break;
					}
				}
			}
			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * This method contains the registrar specific code for fetching the domain access password.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainAccessPassword() {
		global $CONF;
		//Username is in $this->UID
		//Password is in $this->PW

		/*  What to return
		 RegistrarHold 	The enabled status of a domain. If RegistrarHold is True, the domain is disabled.
		 PasswordSet 	Returns 1 if a password is set, 0 otherwise.
		 DomainPassword 	If PasswordSet=1, then a password is returned in this parameter.

		 $this->arrayData["OtherData"]["RegistrarHold"] = 1 or 0;
		 $this->arrayData["OtherData"]["PasswordSet"] = 1 or 0;
		 $this->arrayData["OtherData"]["DomainPassword"] = string;

		 */
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/info",array("Domain"=>$domainName));
		if(strtolower($result["status"])=='failure'){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData["OtherData"]["PasswordSet"]=0;
			if(isset($result["transferauthinfo"])){
				$this->arrayData['DomainAccessPasswordSet']=1;
				$this->arrayData['DomainAccessPassword'] = $result["transferauthinfo"];
			}
			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * This method contains the registrar specific code for setting the domain access password.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function setDomainAccessPassword() {
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$auth=$this->input["domainAccessPassword"];
		$result=$this->runInternetbsCommand("/domain/update",array("Domain"=>$domainName,"transferAuthInfo"=>$auth));
		if(strtolower($result["status"])=='failure'){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData['OtherData'] = $result["status"];
			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * Call the registrar to check TLD pricing cost (cogs).
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getTLDPricing() {
		global $CONF;

		//Username is in $this->UID
		//Password is in $this->PW

		$result=$this->runInternetbsCommand("/Account/PriceList/Get",array("Currency"=>'USD'));
		if(strtolower($result["status"])!='failure'){
			foreach ($result as $key => $value) {
				if(strpos($value,"registration")!==FALSE){
					$v=str_replace("_name","",str_replace("product_","",$key));
					$d=trim(str_replace("registration","",$key)," .");
					$this->arrayData[$d]=$result["product_".$v."_price"];
				}
			}
		} else {
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		}
		$this->hasExecutedSuccessfully = 1;
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * Call the registrar to check the status of a transfer
	 *
	 * @return  string status of the transfer
	 */
	function getTransferStatus() {
		global $CONF;

		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$auth=$this->input["domainAccessPassword"];
		$result=$this->runInternetbsCommand("/domain/update",array("Domain"=>$domainName,"transferAuthInfo"=>$auth));
		if(strtolower($result["status"])=='failure'){
			if($result["code"]=='100011'){//not pending transfer
				$this->hasExecutedSuccessfully = 1;
				$this->arrayData = "Not pending transfer";
			} else {
				$this->setError($result["transactid"],$result["code"],$result["message"]);
				$this->hasExecutedSuccessfully = 0;
			}
		} else {
			$itemNumber=0;
			while(array_key_exists("history_".$itemNumber."_statuscode",$result)){
				$itemNumber++;
			}
			$this->arrayData = $result["history_".($itemNumber-1)."_statuscode"];
			$this->hasExecutedSuccessfully = 1;
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	/**
	 * Call the registrar to get a list of TLDs
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getTLDList() {
		global $CONF;

		foreach ( $this->capabilities[REGISTRAR_TLDS] as $tld )
		{
			$tlds[$tld] = 1;
		}
		$this->arrayData = $tlds;
		$this->hasExecutedSuccessfully = 1;
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}

	function prepareDnsRecord($dnsRecord,$domain){
		$revRecord=strtolower(strrev(trim($dnsRecord)));
		$revDomain=strtolower(strrev(trim($domain)));
		if(strpos($revRecord,$revDomain)===0){
			return strtolower($dnsRecord);
		} else {
			return strtolower($dnsRecord.".".$domain);
		}
	}

	function _handleSetDomainDNSStep($record,&$success, $domainName){
		$keys=array_keys($record);
		if(count($keys)==3){
			$matches=array();
			if(preg_match("/^[a-z]+([0-9]+)$/i",$keys[0],$matches)){
				$idx=$matches[1];
				$addr = trim($record["Address$idx"]);
				if(!empty($addr)){
					if(isset($record["RecordType$idx"]) && in_array(trim($record["RecordType$idx"]),array("URL","FRAME"))){
						//url forwarding
						$data=array(
						"Source"=>$this->prepareDnsRecord($record["HostName$idx"],$domainName),
						'Destination'=>trim($record["Address$idx"])
						);
						if($record["RecordType$idx"]=='FRAME'){
							$data["isFramed"]='YES';
						} else {
							$data["isFramed"]='NO';
						}
						$result=$this->runInternetbsCommand("/Domain/UrlForward/Add",$data);
						if(strtolower($result["status"])=="failure"){
							$this->setError($result["transactid"],$result["code"],$result["message"]);
							$this->arrayData['result'] = "TRANS_REGISTRAR_MANAGE_DNS_FAILED";
						} else {
							$success++;
						}
					} else {
						$data=array(
						"FullRecordName"=>$this->prepareDnsRecord($record["HostName$idx"],$domainName),
						'Value'=>trim($record["Address$idx"]),
						'Type'=>trim($record["RecordType$idx"]),
						);
						$result=$this->runInternetbsCommand("/Domain/DnsRecord/Add",$data);
						if(strtolower($result["status"])=="failure"){
							$this->setError($result["transactid"],$result["code"],$result["message"]);
							$this->arrayData['result'] = "TRANS_REGISTRAR_MANAGE_DNS_FAILED";
						} else {
							$success++;
						}

					}
				}
			}
		}
	}
	function setDomainDNS() {
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		if($this->input['domainDNS']==1){
			//dns records and url forwarding

			//1. delete existing records and forwarding rules
			$result=$this->runInternetbsCommand("/Domain/DnsRecord/List",array("Domain"=>$domainName));
			$dnsList=array();
			if(strtolower($result["status"])!="failure"){
				$cnt=$result['total_records'];
				for($i=0;$i<$cnt;$i++){
					if(!in_array($result["records_".$i."_type"],array('NS','SOA'))){
						$record=$result["records_".$i."_name"];
						$this->runInternetbsCommand("/Domain/DnsRecord/Remove",array("FullRecordName"=>$record,"type"=>$result["records_".$i."_type"]));
					}
				}
			}
			$result=$this->runInternetbsCommand("/Domain/UrlForward/List",array("Domain"=>$domainName));
			if(strtolower($result["status"])!="failure"){
				$cnt=$result['total_rules'];
				for($i=1;$i<=$cnt;$i++){
					$rule=$result["rule_".$i."_source"];
					$this->runInternetbsCommand("/Domain/UrlForward/Remove",array("Source"=>$rule));
				}
			}
			//2. add new records and rules
			$success=0;
			if(isset($this->input["host"][0])){
				foreach ($this->input["host"] as $record) {
					$this->_handleSetDomainDNSStep($record,$success,$domainName);
				}
			} else {
				$this->_handleSetDomainDNSStep($this->input["host"],$success,$domainName);
			}
			if($success>0){
				$this->arrayData['result'] = "TRANS_REGISTRAR_MANAGE_DNS_UPDATED";
				$this->hasExecutedSuccessfully = 1;
			} else {
				$this->arrayData['result'] = "TRANS_REGISTRAR_MANAGE_DNS_FAILED";
				$this->hasExecutedSuccessfully = 0;
			}
		} else {
			//update nameservers
			$nsList=array();
			$i=1;
			while(isset($this->input["domainNameserver$i"])){
				$nsList[]=$this->input["domainNameserver$i"];
				$i++;
			}
			$nsList=trim(implode(",",$nsList)," ,");
			$result = $this->runInternetbsCommand("/Domain/Update",array("Domain"=>$domainName,"Ns_list"=>$nsList));
			if(strtolower($result["status"])=="failure"){
				$this->setError($result["transactid"],$result["code"],$result["message"]);
				$this->arrayData['result'] = "TRANS_REGISTRAR_MANAGE_DNS_FAILED";
				$this->hasExecutedSuccessfully = 0;
			} else {
				$this->arrayData['result'] = "TRANS_REGISTRAR_MANAGE_DNS_UPDATED";
				$this->hasExecutedSuccessfully = 1;
			}
		}
		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}


	function getDomainDNS() {
		global $CONF;
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/info",array("Domain"=>$domainName));
		if(strtolower($result["status"])=="failure"){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			$this->arrayData['dnsOptions'] = array( "A" => "A",'AAAA'=>'AAAA', "URL" => "URL", "MX" => "MX", "CNAME" => "CNAME", "FRAME" => "FRAME", "TXT" => "TXT" );
			$nsList=array();
			foreach ($result as $key => $value) {
				if(strpos($key,"nameserver_")===0){
					$nsList[]=$value;
				}
				$this->arrayData['listDNS']=$nsList;
			}
			$result=$this->runInternetbsCommand("/Domain/DnsRecord/List",array("Domain"=>$domainName));
			$dnsList=array();
			if(strtolower($result["status"])!="failure"){
				$cnt=$result['total_records'];
				for($i=0;$i<$cnt;$i++){
					if(!in_array($result["records_".$i."_type"],array('NS','SOA'))){
						$dnsList[] = array('name'=>$result["records_".$i."_name"],
                             'type'=>strtoupper(trim($result["records_".$i."_type"])),
                             'address'=>$result["records_".$i."_value"],
                             'pref'=>isset($result["records_".$i."_priority"])?$result["records_".$i."_priority"]:0
						);
					}
				}
			}
			$result=$this->runInternetbsCommand("/Domain/UrlForward/List",array("Domain"=>$domainName));
			if(strtolower($result["status"])!="failure"){
				$cnt=$result['total_rules'];
				for($i=1;$i<=$cnt;$i++){
					$dnsList[] = array('name'=>$result["rule_".$i."_source"],
                             'type'=>$result["rule_".$i."_isframed"]=='YES'?'FRAME':'URL',
                             'address'=>str_replace("https://","",str_replace("http://","",$result["rule_".$i."_destination"])),
                             'pref'=>0
					);
				}
			}
			$this->arrayData['host']=$dnsList;
			$this->arrayData['UseDNS']=count($dnsList)>0?1:0;
			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;
	}


	/**
	 * This method contains the registrar specific code for fetching the domain expiration date.
	 *
	 * @return  string xmlData of containting results of the remote registrar connection
	 */
	function getDomainExpDate() {
		global $CONF;

		//What to return
		$domainName=$this->input['domainSLD'].".".$this->input['domainTLD'];
		$result=$this->runInternetbsCommand("/domain/info",array("Domain"=>$domainName));
		if(strtolower($result["status"])=="failure"){
			$this->setError($result["transactid"],$result["code"],$result["message"]);
			$this->hasExecutedSuccessfully = 0;
		} else {
			list($year,$month,$day)=explode("/",$result["expirationdate"]);
			$time=mktime(0,0,0,$month,$day,$year);
			$this->arrayData["DomainExpDate"] = $result["expirationdate"];//"7/8/2007 6:37:25 PM";
			$this->arrayData["DomainExpTimestamp"] = $time; //Unix Timestamp
			$this->hasExecutedSuccessfully = 1;
		}

		$this->hasExecuted = 1;
		$this->xmlData = $this->getRegistrarReturnXML();
		return $this->xmlData;

	}

	/**
	 * Put the contact info in place.  The contact settings can be use as:
	 * $this->registrationArray["contact_set"]["owner"]
	 * $this->registrationArray["contact_set"]["admin"]
	 * $this->registrationArray["contact_set"]["billing"]
	 * $this->registrationArray["contact_set"]["tech"]
	 *
	 */
	function getRegistrationContactsData() {

		//Set the owner info
		$this->registrationArray["contact_set"]["owner"]["first_name"] = $this->input["registrantFirstName"];
		$this->registrationArray["contact_set"]["owner"]["last_name"] = $this->input["registrantLastName"];
		$this->registrationArray["contact_set"]["owner"]["org_name"] = ($this->input["registrantOrganizationName"])? $this->input["registrantOrganizationName"] : $this->input["domainSLD"];
		$this->registrationArray["contact_set"]["owner"]["address1"] = $this->input["registrantAddress1"];
		$this->registrationArray["contact_set"]["owner"]["address2"] = $this->input["registrantAddress2"];
		$this->registrationArray["contact_set"]["owner"]["address3"] = "";
		$this->registrationArray["contact_set"]["owner"]["city"] = $this->input["registrantCity"];
		$this->registrationArray["contact_set"]["owner"]["state"] = $this->input["registrantStateProvince"];
		$this->registrationArray["contact_set"]["owner"]["country"] = $this->input["registrantCountry"];
		$this->registrationArray["contact_set"]["owner"]["postal_code"] = $this->input["registrantPostalCode"];
		$this->registrationArray["contact_set"]["owner"]["email"] = $this->input["registrantEmail"];
		$this->registrationArray["contact_set"]["owner"]["phone"] = $this->input["registrantPhone"];
		$this->registrationArray["contact_set"]["owner"]["fax"] = (strlen($this->input["registrantFax"])>4)? $this->input["registrantFax"] : "";
		$this->registrationArray["contact_set"]["owner"]["url"] = "";
		$this->registrationArray["contact_set"]["owner"]["lang_pref"] = $this->input["domain_idn_language"];

		//If the module has contact fields set, override the client info
		if($this->input["config"]["adminFirstname"] || $this->input["config"]["adminLastName"] || $this->input["config"]["adminCompany"]) {
			$this->registrationArray["contact_set"]["admin"]["first_name"] = $this->input["config"]["adminFirstname"];
			$this->registrationArray["contact_set"]["admin"]["last_name"] = $this->input["config"]["adminLastName"];
			$this->registrationArray["contact_set"]["admin"]["org_name"] = $this->input["config"]["adminCompany"];
			$this->registrationArray["contact_set"]["admin"]["address1"] = $this->input["config"]["adminAddress1"];
			$this->registrationArray["contact_set"]["admin"]["address2"] = $this->input["config"]["adminAddress2"];
			$this->registrationArray["contact_set"]["admin"]["address3"] = "";
			$this->registrationArray["contact_set"]["admin"]["city"] = $this->input["config"]["adminCity"];
			$this->registrationArray["contact_set"]["admin"]["state"] = $this->input["config"]["adminState"];
			$this->registrationArray["contact_set"]["admin"]["country"] = $this->input["config"]["adminCountry"];
			$this->registrationArray["contact_set"]["admin"]["postal_code"] = $this->input["config"]["adminPostalCode"];
			$this->registrationArray["contact_set"]["admin"]["email"] = $this->input["config"]["adminEmail"];
			$this->registrationArray["contact_set"]["admin"]["phone"] = $this->input["config"]["adminPhone"];
			$this->registrationArray["contact_set"]["admin"]["fax"] = (strlen($this->input["config"]["adminFax"])>4)? $this->input["registrantFax"] : "";
			$this->registrationArray["contact_set"]["admin"]["url"] = "";
			//$this->registrationArray["contact_set"]["admin"]["lang_pref"] = $this->input["config"]["domain_idn_language"];
		} else {
			$this->registrationArray["contact_set"]["admin"]["first_name"] = $this->input["registrantFirstName"];
			$this->registrationArray["contact_set"]["admin"]["last_name"] = $this->input["registrantLastName"];
			$this->registrationArray["contact_set"]["admin"]["org_name"] = ($this->input["registrantOrganizationName"])? $this->input["registrantOrganizationName"] : $this->input["domainSLD"];
			$this->registrationArray["contact_set"]["admin"]["address1"] = $this->input["registrantAddress1"];
			$this->registrationArray["contact_set"]["admin"]["address2"] = $this->input["registrantAddress2"];
			$this->registrationArray["contact_set"]["admin"]["address3"] = "";
			$this->registrationArray["contact_set"]["admin"]["city"] = $this->input["registrantCity"];
			$this->registrationArray["contact_set"]["admin"]["state"] = $this->input["registrantState"];
			$this->registrationArray["contact_set"]["admin"]["country"] = $this->input["registrantCountry"];
			$this->registrationArray["contact_set"]["admin"]["postal_code"] = $this->input["registrantPostalCode"];
			$this->registrationArray["contact_set"]["admin"]["email"] = $this->input["registrantEmail"];
			$this->registrationArray["contact_set"]["admin"]["phone"] = $this->input["registrantPhone"];
			$this->registrationArray["contact_set"]["admin"]["fax"] = (strlen($this->input["registrantFax"])>4)? $this->input["registrantFax"] : "";
			$this->registrationArray["contact_set"]["admin"]["url"] = "";
			$this->registrationArray["contact_set"]["admin"]["lang_pref"] = $this->input["domain_idn_language"];
		}
		if($this->input["config"]["auxBillingFirstname"] || $this->input["config"]["auxBillingLastName"] || $this->input["config"]["auxBillingCompany"]) {
			$this->registrationArray["contact_set"]["billing"]["first_name"] = $this->input["config"]["auxBillingFirstname"];
			$this->registrationArray["contact_set"]["billing"]["last_name"] = $this->input["config"]["auxBillingLastName"];
			$this->registrationArray["contact_set"]["billing"]["org_name"] = $this->input["config"]["auxBillingCompany"];
			$this->registrationArray["contact_set"]["billing"]["address1"] = $this->input["config"]["auxBillingAddress1"];
			$this->registrationArray["contact_set"]["billing"]["address2"] = $this->input["config"]["auxBillingAddress2"];
			$this->registrationArray["contact_set"]["billing"]["address3"] = "";
			$this->registrationArray["contact_set"]["billing"]["city"] = $this->input["config"]["auxBillingCity"];
			$this->registrationArray["contact_set"]["billing"]["state"] = $this->input["config"]["auxBillingState"];
			$this->registrationArray["contact_set"]["billing"]["country"] = $this->input["config"]["auxBillingCountry"];
			$this->registrationArray["contact_set"]["billing"]["postal_code"] = $this->input["config"]["auxBillingPostalCode"];
			$this->registrationArray["contact_set"]["billing"]["email"] = $this->input["config"]["auxBillingEmail"];
			$this->registrationArray["contact_set"]["billing"]["phone"] = $this->input["config"]["auxBillingPhone"];
			$this->registrationArray["contact_set"]["billing"]["fax"] = (strlen($this->input["config"]["auxBillingFax"])>4)? $this->input["registrantFax"] : "";
			$this->registrationArray["contact_set"]["billing"]["url"] = "";
			//$this->registrationArray["contact_set"]["admin"]["lang_pref"] = $this->input["config"]["domain_idn_language"];
		} else {
			$this->registrationArray["contact_set"]["billing"]["first_name"] = $this->input["registrantFirstName"];
			$this->registrationArray["contact_set"]["billing"]["last_name"] = $this->input["registrantLastName"];
			$this->registrationArray["contact_set"]["billing"]["org_name"] = ($this->input["registrantOrganizationName"])? $this->input["registrantOrganizationName"] : $this->input["domainSLD"];;
			$this->registrationArray["contact_set"]["billing"]["address1"] = $this->input["registrantAddress1"];
			$this->registrationArray["contact_set"]["billing"]["address2"] = $this->input["registrantAddress2"];
			$this->registrationArray["contact_set"]["billing"]["address3"] = "";
			$this->registrationArray["contact_set"]["billing"]["city"] = $this->input["registrantCity"];
			$this->registrationArray["contact_set"]["billing"]["state"] = $this->input["registrantState"];
			$this->registrationArray["contact_set"]["billing"]["country"] = $this->input["registrantCountry"];
			$this->registrationArray["contact_set"]["billing"]["postal_code"] = $this->input["registrantPostalCode"];
			$this->registrationArray["contact_set"]["billing"]["email"] = $this->input["registrantEmail"];
			$this->registrationArray["contact_set"]["billing"]["phone"] = $this->input["registrantPhone"];
			$this->registrationArray["contact_set"]["billing"]["fax"] = (strlen($this->input["registrantFax"])>4)? $this->input["registrantFax"] : "";
			$this->registrationArray["contact_set"]["billing"]["url"] = "";
			$this->registrationArray["contact_set"]["billing"]["lang_pref"] = $this->input["domain_idn_language"];
		}
		if($this->input["config"]["techFirstname"] || $this->input["config"]["techLastName"] || $this->input["config"]["techCompany"]) {
			$this->registrationArray["contact_set"]["tech"]["first_name"] = $this->input["config"]["techFirstname"];
			$this->registrationArray["contact_set"]["tech"]["last_name"] = $this->input["config"]["techLastName"];
			$this->registrationArray["contact_set"]["tech"]["org_name"] = $this->input["config"]["techCompany"];
			$this->registrationArray["contact_set"]["tech"]["address1"] = $this->input["config"]["techAddress1"];
			$this->registrationArray["contact_set"]["tech"]["address2"] = $this->input["config"]["techAddress2"];
			$this->registrationArray["contact_set"]["tech"]["address3"] = "";
			$this->registrationArray["contact_set"]["tech"]["city"] = $this->input["config"]["techCity"];
			$this->registrationArray["contact_set"]["tech"]["state"] = $this->input["config"]["techState"];
			$this->registrationArray["contact_set"]["tech"]["country"] = $this->input["config"]["techCountry"];
			$this->registrationArray["contact_set"]["tech"]["postal_code"] = $this->input["config"]["techPostalCode"];
			$this->registrationArray["contact_set"]["tech"]["email"] = $this->input["config"]["techEmail"];
			$this->registrationArray["contact_set"]["tech"]["phone"] = $this->input["config"]["techPhone"];
			$this->registrationArray["contact_set"]["tech"]["fax"] = (strlen($this->input["config"]["techFax"])>4)? $this->input["registrantFax"] : "";
			$this->registrationArray["contact_set"]["tech"]["url"] = "";
			//$this->registrationArray["contact_set"]["admin"]["lang_pref"] = $this->input["config"]["domain_idn_language"];
		} else {
			$this->registrationArray["custom_tech_contact"] = 1;
			$this->registrationArray["contact_set"]["tech"]["first_name"] = $this->input["registrantFirstName"];
			$this->registrationArray["contact_set"]["tech"]["last_name"] = $this->input["registrantLastName"];
			$this->registrationArray["contact_set"]["tech"]["org_name"] = ($this->input["registrantOrganizationName"])? $this->input["registrantOrganizationName"] : $this->input["domainSLD"];
			$this->registrationArray["contact_set"]["tech"]["address1"] = $this->input["registrantAddress1"];
			$this->registrationArray["contact_set"]["tech"]["address2"] = $this->input["registrantAddress2"];
			$this->registrationArray["contact_set"]["tech"]["address3"] = "";
			$this->registrationArray["contact_set"]["tech"]["city"] = $this->input["registrantCity"];
			$this->registrationArray["contact_set"]["tech"]["state"] = $this->input["registrantState"];
			$this->registrationArray["contact_set"]["tech"]["country"] = $this->input["registrantCountry"];
			$this->registrationArray["contact_set"]["tech"]["postal_code"] = $this->input["registrantPostalCode"];
			$this->registrationArray["contact_set"]["tech"]["email"] = $this->input["registrantEmail"];
			$this->registrationArray["contact_set"]["tech"]["phone"] = $this->input["registrantPhone"];
			$this->registrationArray["contact_set"]["tech"]["fax"] = (strlen($this->input["registrantFax"])>4)? $this->input["registrantFax"] : "";
			$this->registrationArray["contact_set"]["tech"]["url"] = "";
			$this->registrationArray["contact_set"]["tech"]["lang_pref"] = $this->input["domain_idn_language"];
		}

		$contactData=array(
		'registrant_firstname' => $this->registrationArray["contact_set"]["owner"]["first_name"],
        'registrant_lastname' => $this->registrationArray["contact_set"]["owner"]["last_name"],
		'registrant_organization'=> $this->registrationArray["contact_set"]["owner"]["org_name"],
        'registrant_street' => $this->registrationArray["contact_set"]["owner"]["address1"],
        'registrant_street2' => $this->registrationArray["contact_set"]["owner"]["address2"],
        'registrant_city' => $this->registrationArray["contact_set"]["owner"]["city"],
        'registrant_countrycode' => $this->registrationArray["contact_set"]["owner"]["country"],
        'registrant_postalcode' => $this->registrationArray["contact_set"]["owner"]["postal_code"],
        'registrant_email' => $this->registrationArray["contact_set"]["owner"]["email"],
        'registrant_phonenumber' =>$this->_formatPhoneNumber($this->registrationArray["contact_set"]["owner"]["phone"],$this->registrationArray["contact_set"]["owner"]["country"]),

		// technical contact data
		'technical_firstname' => $this->registrationArray["contact_set"]["tech"]["first_name"],
		'technical_lastname' => $this->registrationArray["contact_set"]["tech"]["last_name"],
		'technical_organization'=> $this->registrationArray["contact_set"]["tech"]["org_name"],
		'technical_street' => $this->registrationArray["contact_set"]["tech"]["address1"],
		'technical_street2' => $this->registrationArray["contact_set"]["tech"]["address2"],
		'technical_city' => $this->registrationArray["contact_set"]["tech"]["city"],
		'technical_countrycode' => $this->registrationArray["contact_set"]["tech"]["country"],
		'technical_postalcode' => $this->registrationArray["contact_set"]["tech"]["postal_code"],
		'technical_email' => $this->registrationArray["contact_set"]["tech"]["email"],
		'technical_phonenumber' => $this->_formatPhoneNumber($this->registrationArray["contact_set"]["tech"]["phone"],$this->registrationArray["contact_set"]["tech"]["country"]),
		// admin contact data
        'admin_firstname' => $this->registrationArray["contact_set"]["admin"]["first_name"],
		'admin_lastname' => $this->registrationArray["contact_set"]["admin"]["last_name"],
		'admin_organization'=> $this->registrationArray["contact_set"]["admin"]["org_name"],
		'admin_street' => $this->registrationArray["contact_set"]["admin"]["address1"],
		'admin_street2' => $this->registrationArray["contact_set"]["admin"]["address2"],
		'admin_city' => $this->registrationArray["contact_set"]["admin"]["city"],
		'admin_countrycode' => $this->registrationArray["contact_set"]["admin"]["country"],
		'admin_postalcode' => $this->registrationArray["contact_set"]["admin"]["postal_code"],
		'admin_email' => $this->registrationArray["contact_set"]["admin"]["email"],
		'admin_phonenumber' => $this->_formatPhoneNumber($this->registrationArray["contact_set"]["admin"]["phone"],$this->registrationArray["contact_set"]["admin"]["country"]),

		// billing contact data
		'billing_firstname' => $this->registrationArray["contact_set"]["billing"]["first_name"],
		'billing_lastname' => $this->registrationArray["contact_set"]["billing"]["last_name"],
		'billing_organization'=> $this->registrationArray["contact_set"]["billing"]["org_name"],
		'billing_street' => $this->registrationArray["contact_set"]["billing"]["address1"],
		'billing_street2' => $this->registrationArray["contact_set"]["billing"]["address2"],
		'billing_city' => $this->registrationArray["contact_set"]["billing"]["city"],
		'billing_countrycode' => $this->registrationArray["contact_set"]["billing"]["country"],
		'billing_postalcode' => $this->registrationArray["contact_set"]["billing"]["postal_code"],
		'billing_email' => $this->registrationArray["contact_set"]["billing"]["email"],
		'billing_phonenumber' => $this->_formatPhoneNumber($this->registrationArray["contact_set"]["billing"]["phone"],$this->registrationArray["contact_set"]["billing"]["country"]),

		);

		$ext=$this->input['domainTLD'];
		if($ext=='uk') {

			$legalType = $this->input["uk_legal_type"];
			$dotUKOrgType = "";
			switch($legalType) {
				case "Non-UK" :
					$dotUKOrgType = "FIND";
					break;
				default:
					$dotUKOrgType = strtoupper($legalType);
					break;
			}

			if(in_array($dotUKOrgType, array('LTD', 'PLC', 'LLP', 'IP', 'SCH', 'RCHAR'))) {
				$contactData['registrant_dotUKRegistrationNumber'] = $this->input["uk_reg_co_no"];
			}

			// organization type
			$contactData['registrant_dotUKOrgType'] = $dotUKOrgType;
			if($contactData['registrant_dotUKOrgType']=='IND') {
				$contactData['registrant_dotUKOptOut']  = $this->input["uk_reg_opt_out"];
			}

			$contactData['registrant_Organization'] = $this->input["registered_for"];
		} else if($ext=='eu') {
			$contactData['registrant_Language'] = $this->input["eu_adr_lang"];
		} else if($ext=='fr') {
			$holderType = isset($this->input["siren"]) && trim($this->input["siren"])!='' ? 'COMPANY' : 'INDIVIDUAL';

			$contactData['registrant_dotfrcontactentitytype'] = $holderType;
			$contactData['admin_dotfrcontactentitytype'] = $holderType;

			switch($holderType) {
				case 'INDIVIDUAL' :
					$dob=$this->input["registrant_dob"];
					list($day,$month,$year)=explode("/",$dob);
					$contactData["registrant_dotfrcontactentitybirthdate"] = "$year-$month-$day";
					$contactData['registrant_dotfrcontactentitybirthplacecountrycode'] = $this->_getCountryCode($this->input["country"],$this->input["registrantCountry"]);
					$contactData['admin_dotfrcontactentitybirthdate'] = "$year-$month-$day";
					$contactData['admin_dotfrcontactentitybirthplacecountrycode'] = $contactData['registrant_dotfrcontactentitybirthplacecountrycode'];
					if(strtolower($contactData['admin_dotfrcontactentitybirthplacecountrycode'])=='fr') {
						$contactData['registrant_dotFRContactEntityBirthCity'] = $this->input["city"];
						$contactData['registrant_dotFRContactEntityBirthPlacePostalCode'] = $this->input["postalcode"];
						$contactData['admin_dotFRContactEntityBirthCity'] = $this->input["city"];
						$contactData['admin_dotFRContactEntityBirthPlacePostalCode'] = $this->input["postalcode"];
					}
					break;
				case 'COMPANY' :
					$contactData['registrant_dotFRContactEntitySiren'] = $this->input["siren"];
					$contactData['admin_dotFRContactEntitySiren'] = $this->input["siren"];
					break;
			}
		}

		return $contactData;
	}

	function _getCountryCode($country,$default='BS'){
		$countries=array(
		array('AALAND ISLANDS','AX','ALA'),
		array('AFGHANISTAN','AF','AFG'),
		array('ALBANIA','AL','ALB'),
		array('ALGERIA','DZ','DZA'),
		array('AMERICAN SAMOA','AS','ASM'),
		array('ANDORRA','AD','AND'),
		array('ANGOLA','AO','AGO'),
		array('ANGUILLA','AI','AIA'),
		array('ANTARCTICA','AQ','ATA'),
		array('ANTIGUA AND BARBUDA','AG','ATG'),
		array('ARGENTINA','AR','ARG'),
		array('ARMENIA','AM','ARM'),
		array('ARUBA','AW','ABW'),
		array('AUSTRALIA','AU','AUS'),
		array('AUSTRIA','AT','AUT'),
		array('AZERBAIJAN','AZ','AZE'),
		array('BAHAMAS','BS','BHS'),
		array('BAHRAIN','BH','BHR'),
		array('BANGLADESH','BD','BGD'),
		array('BARBADOS','BB','BRB'),
		array('BELARUS','BY','BLR'),
		array('BELGIUM','BE','BEL'),
		array('BELIZE','BZ','BLZ'),
		array('BENIN','BJ','BEN'),
		array('BERMUDA','BM','BMU'),
		array('BHUTAN','BT','BTN'),
		array('BOLIVIA','BO','BOL'),
		array('BOSNIA AND HERZEGOWINA','BA','BIH'),
		array('BOTSWANA','BW','BWA'),
		array('BOUVET ISLAND','BV','BVT'),
		array('BRAZIL','BR','BRA'),
		array('BRITISH INDIAN OCEAN TERRITORY','IO','IOT'),
		array('BRUNEI DARUSSALAM','BN','BRN'),
		array('BULGARIA','BG','BGR'),
		array('BURKINA FASO','BF','BFA'),
		array('BURUNDI','BI','BDI'),
		array('CAMBODIA','KH','KHM'),
		array('CAMEROON','CM','CMR'),
		array('CANADA','CA','CAN'),
		array('CAPE VERDE','CV','CPV'),
		array('CAYMAN ISLANDS','KY','CYM'),
		array('CENTRAL AFRICAN REPUBLIC','CF','CAF'),
		array('CHAD','TD','TCD'),
		array('CHILE','CL','CHL'),
		array('CHINA','CN','CHN'),
		array('CHRISTMAS ISLAND','CX','CXR'),
		array('COCOS (KEELING) ISLANDS','CC','CCK'),
		array('COLOMBIA','CO','COL'),
		array('COMOROS','KM','COM'),
		array('CONGO, Democratic Republic of (was Zaire)','CD','COD'),
		array('CONGO, Republic of','CG','COG'),
		array('COOK ISLANDS','CK','COK'),
		array('COSTA RICA','CR','CRI'),
		array('COTE D\'IVOIRE','CI','CIV'),
		array('CROATIA (local name: Hrvatska)','HR','HRV'),
		array('CUBA','CU','CUB'),
		array('CYPRUS','CY','CYP'),
		array('CZECH REPUBLIC','CZ','CZE'),
		array('DENMARK','DK','DNK'),
		array('DJIBOUTI','DJ','DJI'),
		array('DOMINICA','DM','DMA'),
		array('DOMINICAN REPUBLIC','DO','DOM'),
		array('ECUADOR','EC','ECU'),
		array('EGYPT','EG','EGY'),
		array('EL SALVADOR','SV','SLV'),
		array('EQUATORIAL GUINEA','GQ','GNQ'),
		array('ERITREA','ER','ERI'),
		array('ESTONIA','EE','EST'),
		array('ETHIOPIA','ET','ETH'),
		array('FALKLAND ISLANDS (MALVINAS)','FK','FLK'),
		array('FAROE ISLANDS','FO','FRO'),
		array('FIJI','FJ','FJI'),
		array('FINLAND','FI','FIN'),
		array('FRANCE','FR','FRA'),
		array('FRENCH GUIANA','GF','GUF'),
		array('FRENCH POLYNESIA','PF','PYF'),
		array('FRENCH SOUTHERN TERRITORIES','TF','ATF'),
		array('GABON','GA','GAB'),
		array('GAMBIA','GM','GMB'),
		array('GEORGIA','GE','GEO'),
		array('GERMANY','DE','DEU'),
		array('GHANA','GH','GHA'),
		array('GIBRALTAR','GI','GIB'),
		array('GREECE','GR','GRC'),
		array('GREENLAND','GL','GRL'),
		array('GRENADA','GD','GRD'),
		array('GUADELOUPE','GP','GLP'),
		array('GUAM','GU','GUM'),
		array('GUATEMALA','GT','GTM'),
		array('GUINEA','GN','GIN'),
		array('GUINEA-BISSAU','GW','GNB'),
		array('GUYANA','GY','GUY'),
		array('HAITI','HT','HTI'),
		array('HEARD AND MC DONALD ISLANDS','HM','HMD'),
		array('HONDURAS','HN','HND'),
		array('HONG KONG','HK','HKG'),
		array('HUNGARY','HU','HUN'),
		array('ICELAND','IS','ISL'),
		array('INDIA','IN','IND'),
		array('INDONESIA','ID','IDN'),
		array('IRAN (ISLAMIC REPUBLIC OF)','IR','IRN'),
		array('IRAQ','IQ','IRQ'),
		array('IRELAND','IE','IRL'),
		array('ISRAEL','IL','ISR'),
		array('ITALY','IT','ITA'),
		array('JAMAICA','JM','JAM'),
		array('JAPAN','JP','JPN'),
		array('JORDAN','JO','JOR'),
		array('KAZAKHSTAN','KZ','KAZ'),
		array('KENYA','KE','KEN'),
		array('KIRIBATI','KI','KIR'),
		array('KOREA, DEMOCRATIC PEOPLE\'S REPUBLIC OF','KP','PRK'),
		array('KOREA, REPUBLIC OF','KR','KOR'),
		array('KUWAIT','KW','KWT'),
		array('KYRGYZSTAN','KG','KGZ'),
		array('LAO PEOPLE\'S DEMOCRATIC REPUBLIC','LA','LAO'),
		array('LATVIA','LV','LVA'),
		array('LEBANON','LB','LBN'),
		array('LESOTHO','LS','LSO'),
		array('LIBERIA','LR','LBR'),
		array('LIBYAN ARAB JAMAHIRIYA','LY','LBY'),
		array('LIECHTENSTEIN','LI','LIE'),
		array('LITHUANIA','LT','LTU'),
		array('LUXEMBOURG','LU','LUX'),
		array('MACAU','MO','MAC'),
		array('MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF','MK','MKD'),
		array('MADAGASCAR','MG','MDG'),
		array('MALAWI','MW','MWI'),
		array('MALAYSIA','MY','MYS'),
		array('MALDIVES','MV','MDV'),
		array('MALI','ML','MLI'),
		array('MALTA','MT','MLT'),
		array('MARSHALL ISLANDS','MH','MHL'),
		array('MARTINIQUE','MQ','MTQ'),
		array('MAURITANIA','MR','MRT'),
		array('MAURITIUS','MU','MUS'),
		array('MAYOTTE','YT','MYT'),
		array('MEXICO','MX','MEX'),
		array('MICRONESIA, FEDERATED STATES OF','FM','FSM'),
		array('MOLDOVA, REPUBLIC OF','MD','MDA'),
		array('MONACO','MC','MCO'),
		array('MONGOLIA','MN','MNG'),
		array('MONTSERRAT','MS','MSR'),
		array('MOROCCO','MA','MAR'),
		array('MOZAMBIQUE','MZ','MOZ'),
		array('MYANMAR','MM','MMR'),
		array('NAMIBIA','NA','NAM'),
		array('NAURU','NR','NRU'),
		array('NEPAL','NP','NPL'),
		array('NETHERLANDS','NL','NLD'),
		array('NETHERLANDS ANTILLES','AN','ANT'),
		array('NEW CALEDONIA','NC','NCL'),
		array('NEW ZEALAND','NZ','NZL'),
		array('NICARAGUA','NI','NIC'),
		array('NIGER','NE','NER'),
		array('NIGERIA','NG','NGA'),
		array('NIUE','NU','NIU'),
		array('NORFOLK ISLAND','NF','NFK'),
		array('NORTHERN MARIANA ISLANDS','MP','MNP'),
		array('NORWAY','NO','NOR'),
		array('OMAN','OM','OMN'),
		array('PAKISTAN','PK','PAK'),
		array('PALAU','PW','PLW'),
		array('PALESTINIAN TERRITORY, Occupied','PS','PSE'),
		array('PANAMA','PA','PAN'),
		array('PAPUA NEW GUINEA','PG','PNG'),
		array('PARAGUAY','PY','PRY'),
		array('PERU','PE','PER'),
		array('PHILIPPINES','PH','PHL'),
		array('PITCAIRN','PN','PCN'),
		array('POLAND','PL','POL'),
		array('PORTUGAL','PT','PRT'),
		array('PUERTO RICO','PR','PRI'),
		array('QATAR','QA','QAT'),
		array('REUNION','RE','REU'),
		array('ROMANIA','RO','ROU'),
		array('RUSSIAN FEDERATION','RU','RUS'),
		array('RWANDA','RW','RWA'),
		array('SAINT HELENA','SH','SHN'),
		array('SAINT KITTS AND NEVIS','KN','KNA'),
		array('SAINT LUCIA','LC','LCA'),
		array('SAINT PIERRE AND MIQUELON','PM','SPM'),
		array('SAINT VINCENT AND THE GRENADINES','VC','VCT'),
		array('SAMOA','WS','WSM'),
		array('SAN MARINO','SM','SMR'),
		array('SAO TOME AND PRINCIPE','ST','STP'),
		array('SAUDI ARABIA','SA','SAU'),
		array('SENEGAL','SN','SEN'),
		array('SERBIA AND MONTENEGRO','CS','SCG'),
		array('SEYCHELLES','SC','SYC'),
		array('SIERRA LEONE','SL','SLE'),
		array('SINGAPORE','SG','SGP'),
		array('SLOVAKIA','SK','SVK'),
		array('SLOVENIA','SI','SVN'),
		array('SOLOMON ISLANDS','SB','SLB'),
		array('SOMALIA','SO','SOM'),
		array('SOUTH AFRICA','ZA','ZAF'),
		array('SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS','GS','SGS'),
		array('SPAIN','ES','ESP'),
		array('SRI LANKA','LK','LKA'),
		array('SUDAN','SD','SDN'),
		array('SURINAME','SR','SUR'),
		array('SVALBARD AND JAN MAYEN ISLANDS','SJ','SJM'),
		array('SWAZILAND','SZ','SWZ'),
		array('SWEDEN','SE','SWE'),
		array('SWITZERLAND','CH','CHE'),
		array('SYRIAN ARAB REPUBLIC','SY','SYR'),
		array('TAIWAN','TW','TWN'),
		array('TAJIKISTAN','TJ','TJK'),
		array('TANZANIA, UNITED REPUBLIC OF','TZ','TZA'),
		array('THAILAND','TH','THA'),
		array('TIMOR-LESTE','TL','TLS'),
		array('TOGO','TG','TGO'),
		array('TOKELAU','TK','TKL'),
		array('TONGA','TO','TON'),
		array('TRINIDAD AND TOBAGO','TT','TTO'),
		array('TUNISIA','TN','TUN'),
		array('TURKEY','TR','TUR'),
		array('TURKMENISTAN','TM','TKM'),
		array('TURKS AND CAICOS ISLANDS','TC','TCA'),
		array('TUVALU','TV','TUV'),
		array('UGANDA','UG','UGA'),
		array('UKRAINE','UA','UKR'),
		array('UNITED ARAB EMIRATES','AE','ARE'),
		array('UNITED KINGDOM','GB','GBR'),
		array('UNITED STATES','US','USA'),
		array('UNITED STATES MINOR OUTLYING ISLANDS','UM','UMI'),
		array('URUGUAY','UY','URY'),
		array('UZBEKISTAN','UZ','UZB'),
		array('VANUATU','VU','VUT'),
		array('VATICAN CITY STATE (HOLY SEE)','VA','VAT'),
		array('VENEZUELA','VE','VEN'),
		array('VIET NAM','VN','VNM'),
		array('VIRGIN ISLANDS (BRITISH)','VG','VGB'),
		array('VIRGIN ISLANDS (U.S.)','VI','VIR'),
		array('WALLIS AND FUTUNA ISLANDS','WF','WLF'),
		array('WESTERN SAHARA','EH','ESH'),
		array('YEMEN','YE','YEM'),
		array('ZAMBIA','ZM','ZMB'),
		array('ZIMBABWE','ZW','ZWE')
		);

		$country=strtoupper($country);
		foreach ($countries as $c) {
			if(in_array($country,$c)){
				return $c[1];
			}
		}
		return $default;
	}
	/**
	 *	This fucntion will return the map of all possible values with the names needed to pass to the registrar
	 * not needed
	 *
	 * @return Returns the Registrar map array for this registrar
	 */
	function getAttributesMap() {

		return array
		(
		// Primary Domain Vars
		"domainSLD" => "",
		"domainTLD" => "",
		"domainIDN" => "",
		"domainYears" => "",
		"domainDNS" => "",
		"domainNameserver1" => "",
		"domainNameserver2" => "",
		"domainNameserver3" => "",
		"domainNameserver4" => "",
		"domainNameserver5" => "",
		"domainNameserver6" => "",
		"domainNameserver7" => "",
		"domainNameserver8" => "",

		// check availability
		"checkNameSpinner" => "",
		"checkAllTLDs" => "",
		"checkWithDashes" => "",
		"checkKeyword1" => "",
		"checkKeyword2" => "",
		"checkKeyword3" => "",

		// Extended Domain Vars
		// .us domains
		"domainNexusCategory" => "",
		"domainNexusPurpose" => "",
		"domainNexusValidator" => "",
		// .jp domains
		"domainPrefecture" => "",
		// .eu
		"eu_agreedelete" => "",
		"eu_adr_lang" => "",

		// RegistrarLock Options Vars
		"domainRegistrarLock" => "",

		// AutoRenew Options Vars
		"domainRenewType" => "", // "RenewName"
		"emailForwardAutoRenew" => "",
		"IDProtectAutoRenew" => "",
		"URLForwardAutoRenew" => "",

		// Access Password Vars for Registrar Domain Management
		"domainAccessPassword" => "",
		"domainAccessUsername" => "",

		// ContactType=REGISTRANT Vars
		"registrantFirstName" => "",
		"registrantLastName" => "",
		"registrantJobTitle" => "",
		"registrantCompany" => "",
		"registrantAddress1" => "",
		"registrantAddress2" => "",
		"registrantAddress3" => "",
		"registrantCity" => "",
		"registrantStateProvinceChoice" => "",
		"registrantState" => "",
		"registrantPostalCode" => "",
		"registrantCountry" => "",
		"registrantPhone" => "",
		"registrantPhoneExt" => "",
		"registrantFax" => "",
		"registrantEmail" => "",

		// ContactType=TECH Vars
		"techFirstName" => "",
		"techLastName" => "",
		"techJobTitle" => "",
		"techCompany" => "",
		"techAddress1" => "",
		"techAddress2" => "",
		"techAddress3" => "",
		"techCity" => "",
		"techStateProvinceChoice" => "",
		"techState" => "",
		"techPostalCode" => "",
		"techCountry" => "",
		"techPhone" => "",
		"techPhoneExt" => "",
		"techFax" => "",
		"techEmail" => "",

		// ContactType=ADMIN Vars
		"adminFirstName" => "",
		"adminLastName" => "",
		"adminJobTitle" => "",
		"adminCompany" => "",
		"adminAddress1" => "",
		"adminAddress2" => "",
		"adminAddress3" => "",
		"adminCity" => "",
		"adminStateProvinceChoice" => "",
		"adminState" => "",
		"adminPostalCode" => "",
		"adminCountry" => "",
		"adminPhone" => "",
		"adminPhoneExt" => "",
		"adminFax" => "",
		"adminEmail" => "",

		/*// ContactType=AUXBILLING Vars
		 "auxBillingFirstName" => "",
		 "auxBillingLastName" => "",
		 "auxBillingJobTitle" => "",
		 "auxBillingCompany" => "",
		 "auxBillingAddress1" => "",
		 "auxBillingAddress2" => "",
		 "auxBillingAddress3" => "",
		 "auxBillingCity" => "",
		 "auxBillingStateProvinceChoice" => "",
		 "auxBillingState" => "",
		 "auxBillingPostalCode" => "",
		 "auxBillingCountry" => "",
		 "auxBillingPhone" => "",
		 "auxBillingPhoneExt" => "",
		 "auxBillingFax" => "",
		 "auxBillingEmail" => "",*/

		);

	} // END getAttributesMap()


	/**
	 * Returns the default configuration parameters for the RegistrarShell module. The number of elements in each array must be identical to
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 *
	 * @return	An array of arrays containing all the parameters the module uses.
	 */

	function addDefaultConfigParams() {
		//This needs to be tested with SetConfigGroups once a "add registrarshell" link is added to the GUI
		$defaultConfigParams = array(
		array(NULL, NULL, "moduleEnabled", "1", "TRANS_INTERNETBS_ADMIN_ACCOUNT", "Enable Internet.bs Corp. registrar plugin", "", "r", 1,1,0,array
		(array(NULL,NULL,"0","TRANS_NO",1),
		array(NULL,NULL,"1","TRANS_YES",2))),
		//array(NULL, NULL, "moduleDisplayName", "", "TRANS_INTERNETBS_ADMIN_ACCOUNT", "TRANS_DISPLAY_NAME", "Internet.bs Corp.", "t", 0,2,0, NULL),
		array(NULL, NULL, "moduleUsername", "", "TRANS_INTERNETBS_ADMIN_ACCOUNT", "Internet.bs API key", "", "t", 0,2,0, NULL),
		array(NULL, NULL, "modulePassword", "", "TRANS_INTERNETBS_ADMIN_ACCOUNT", "TRANS_REGISTRAR_PASSWORD", "", "t", 0,3,0, NULL),
		array(NULL, NULL, "moduleTestMode", "1", "TRANS_INTERNETBS_ADMIN_ACCOUNT", "Use test server (for testing purposes)", "", "r", 0,4,0,array
		(array(NULL,NULL,"0","TRANS_NO",1),
		array(NULL,NULL,"1","TRANS_YES",2))),

		// admin contact data
		array(NULL, NULL, "adminFirstName", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_FIRST_NAME", "", "t", 0,19,0, NULL),
		array(NULL, NULL, "adminLastName", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_LAST_NAME", "", "t", 0,20,0, NULL),
		array(NULL, NULL, "adminCompany", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_COMPANY", "", "t", 0,21,0, NULL),
		array(NULL, NULL, "adminEmail", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_EMAIL", "", "t", 0,22,0, NULL),
		array(NULL, NULL, "adminAddress1", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_ADDRESS1", "", "t", 0,23,0, NULL),
		array(NULL, NULL, "adminAddress2", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_ADDRESS2", "", "t", 0,24,0, NULL),
		array(NULL, NULL, "adminCity", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_CITY", "", "t", 0,25,0, NULL),
		array(NULL, NULL, "adminState", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_STATE", "", "t", 0,26,0, NULL),
		array(NULL, NULL, "adminPostalCode", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_ZIP", "", "t", 0,27,0, NULL),
		array(NULL, NULL, "adminCountry", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_COUNTRY", "", "t", 0,28,0, NULL),
		array(NULL, NULL, "adminPhone", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_PHONE", "", "t", 0,29,0, NULL),
		array(NULL, NULL, "adminFax", "", "TRANS_REGISTRAR_ADMIN_CONTACT", "TRANS_REGISTRAR_FAX", "", "t", 0,30,0, NULL),

		array(NULL, NULL, "techFirstName", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_FIRST_NAME", "", "t", 0,31,0, NULL),
		array(NULL, NULL, "techLastName", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_LAST_NAME", "", "t", 0,32,0, NULL),
		array(NULL, NULL, "techCompany", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_COMPANY", "", "t", 0,33,0, NULL),
		array(NULL, NULL, "techEmail", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_EMAIL", "", "t", 0,34,0, NULL),
		array(NULL, NULL, "techAddress1", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_ADDRESS1", "", "t", 0,35,0, NULL),
		array(NULL, NULL, "techAddress2", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_ADDRESS2", "", "t", 0,36,0, NULL),
		array(NULL, NULL, "techCity", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_CITY", "", "t", 0,37,0, NULL),
		array(NULL, NULL, "techState", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_STATE", "", "t", 0,38,0, NULL),
		array(NULL, NULL, "techPostalCode", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_ZIP", "", "t", 0,39,0, NULL),
		array(NULL, NULL, "techCountry", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_COUNTRY", "", "t", 0,40,0, NULL),
		array(NULL, NULL, "techPhone", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_PHONE", "", "t", 0,41,0, NULL),
		array(NULL, NULL, "techFax", "", "TRANS_REGISTRAR_TECH_CONTACT", "TRANS_REGISTRAR_FAX", "", "t", 0,42,0, NULL),

		/*		array(NULL, NULL, "auxBillingFirstName", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_FIRST_NAME", "", "t", 0,43,0, NULL),
		 array(NULL, NULL, "auxBillingLastName", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_LAST_NAME", "", "t", 0,44,0, NULL),
		 array(NULL, NULL, "auxBillingCompany", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_COMPANY", "", "t", 0,45,0, NULL),
		 array(NULL, NULL, "auxBillingEmail", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_EMAIL", "", "t", 0,46,0, NULL),
		 array(NULL, NULL, "auxBillingAddress1", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_ADDRESS1", "", "t", 0,47,0, NULL),
		 array(NULL, NULL, "auxBillingAddress2", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_ADDRESS2", "", "t", 0,48,0, NULL),
		 array(NULL, NULL, "auxBillingCity", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_CITY", "", "t", 0,49,0, NULL),
		 array(NULL, NULL, "auxBillingState", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_STATE", "", "t", 0,50,0, NULL),
		 array(NULL, NULL, "auxBillingPostalCode", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_ZIP", "", "t", 0,51,0, NULL),
		 array(NULL, NULL, "auxBillingCountry", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_COUNTRY", "", "t", 0,52,0, NULL),
		 array(NULL, NULL, "auxBillingPhone", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_PHONE", "", "t", 0,53,0, NULL),
		 array(NULL, NULL, "auxBillingFax", "", "TRANS_REGISTRAR_AUXBILLING_CONTACT", "TRANS_REGISTRAR_FAX", "", "t", 0,54,0, NULL),
		 */		array(NULL, NULL, "domainNameserver1", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS1", "", "t", 0,55,0, NULL),
		array(NULL, NULL, "domainNameserver2", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS2", "", "t", 0,56,0, NULL),
		array(NULL, NULL, "domainNameserver3", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS3", "", "t", 0,57,0, NULL),
		array(NULL, NULL, "domainNameserver4", "", "TRANS_REGISTRAR_NS", "TRANS_REGISTRAR_NS4", "", "t", 0,58,0, NULL),

		); // $defaultConfigParams = array(


		// Grab the configs set at the registrar level
		//return array_merge($this->configParams,$defaultConfigParams);
		return $defaultConfigParams;

	} // END addDefaultConfigParams()

} // InternetBsCorp

?>
